# -*- coding: utf-8 -*-
from utilities import alert_manager


class Alerts(object):

    def __init__(self, cluster_id):

        self._info = None
        self.attr_to_handler = tuple()
        self._cluster_id = cluster_id
        self._alert_manager = alert_manager.AlertManager()

    def generate_alerts(self, stats, info=None):

        if not stats or stats.get("node_status") == "off":
            return

        self._stats = stats
        self._info = info

        for attr, handler in self.attr_to_handler:
            getattr(self, handler)()

    def create_alert(self, msg, status, node_address, alert_type, last_id=None):

        if last_id is not None:
            self._alert_manager.mark_it_to_delete(last_id)

        delete_it = 0
        if status == "green":
            delete_it = 1

        return self._alert_manager.add_alert(
            self._cluster_id,
            msg,
            node_address,
            status,
            alert_type,
            delete_it)

    def get_alert_status(self, red_condition, yellow_condition=None):

        if red_condition:
            return "red"
        elif yellow_condition:
            return "yellow"
        else:
            return "green"
